%define with_struts 1
%define with_maven 0

Name:          velocity-tools
Version:       2.0
Release:       %mkrel 3
Summary:       Collection of useful tools for Velocity template engine
Group:         Development/Java
License:       ASL 2.0
Url:           http://velocity.apache.org/tools/releases/2.0/
Source0:       ftp://ftp.gbnet.net/pub/apache/dist/velocity/tools/2.0/velocity-tools-2.0-src.tar.gz

Patch0:        velocity-tools-2.0-dont_copy_test_lib.patch
Patch1:        velocity-tools-2.0-junit4.patch
Patch2:        velocity-tools-2.0-jetty.patch
# remove struts 1.3.8
Patch3:        velocity-tools-2.0-no-struts.patch

Patch4:        velocity-tools-2.0-jsp-2.1-api.patch

BuildRequires: jpackage-utils
BuildRequires: java-devel

BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-digester
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-validator
BuildRequires: dom4j
BuildRequires: jakarta-oro
BuildRequires: junit4
BuildRequires: tomcat6-jsp-2.1-api
BuildRequires: tomcat6-servlet-2.5-api
BuildRequires: velocity

%if %with_struts
BuildRequires: sslext
BuildRequires: struts >= 1.3.10-1
%endif

%if !%with_maven
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: antlr
%else
BuildRequires: apache-portlet-1.0-api
BuildRequires: avalon-framework
BuildRequires: avalon-logkit
BuildRequires: commons-chain
BuildRequires: httpunit >= 1.7-0.0.5
BuildRequires: jetty
BuildRequires: liblog4j-java
BuildRequires: maven
BuildRequires: maven-changelog-plugin
BuildRequires: maven-changes-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-jxr
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: myfaces-core
BuildRequires: nekohtml
BuildRequires: rhino
BuildRequires: taglist-maven-plugin
BuildRequires: xerces-j2
BuildRequires: xml-commons-apis
%endif

Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
The VelocityTools project is a collection of useful Java classes (aka tools),
as well as infrastructure to easily, automatically and transparently
make these tools available to Velocity templates.
.
Project include easy integration of Velocity into the view-layer of
web applications (via the VelocityViewTag and
VelocityViewServlet) and integration with Struts 1.x applications.

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}-src

for f in $(find . -name "*.jar"); do
  mv $f $f.no
done

%patch0 -p1
%patch1 -p1
%patch2 -p0

%if !%with_struts
%patch3 -p0
%endif
%patch4 -p0

%build

%if !%with_maven
  export CLASSPATH=""
%if %with_struts
  CLASSPATH=$CLASSPATH:$(build-classpath struts/core struts/taglib struts/tiles sslext)
%endif
  CLASSPATH=$CLASSPATH:$(build-classpath antlr commons-beanutils commons-beanutils-core commons-collections)
  CLASSPATH=$CLASSPATH:$(build-classpath commons-digester commons-lang commons-logging commons-validator oro)
  CLASSPATH=$CLASSPATH:$(build-classpath tomcat6-jsp-api tomcat6-servlet-api velocity junit4 ant/ant-junit dom4j)
  ant -Dskip-download=true \
%if %with_struts
  jar.struts \
%else
  jar.view jar.generic \
%endif
 javadoc
#  docs org.apache.dvsl.DVSLTask
%else
  %if !%with_struts
    rm -rf src/main/java/org/apache/velocity/tools/struts
  %endif
  mvn-rpmbuild -e -Dmaven.test.failure.ignore=true  install javadoc:aggregate

%endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}

%if %with_struts
  install -pm 644 dist/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}.jar
  (
    cd %{buildroot}%{_javadir}
    ln -sf %{name}.jar %{name}-generic.jar
    ln -sf %{name}.jar %{name}-view.jar
  )
%else
  install -pm 644 dist/%{name}-generic-%{version}.jar %{buildroot}%{_javadir}/%{name}-generic.jar
  install -pm 644 dist/%{name}-view-%{version}.jar %{buildroot}%{_javadir}/%{name}-view.jar
%endif

mkdir -p %{buildroot}%{_javadocdir}/%{name}
%if !%with_maven
  cp -pr docs/javadoc/* %{buildroot}%{_javadocdir}/%{name}
%else
  cp -pr dist/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}
%endif

mkdir -p  %{buildroot}%{_mavenpomdir}
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%if %with_struts
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}
%add_to_maven_depmap org.apache.velocity %{name} %{version} JPP %{name}
%endif
%add_to_maven_depmap %{name} %{name}-generic %{version} JPP %{name}-generic
%add_to_maven_depmap %{name} %{name}-view %{version} JPP %{name}-view
%add_to_maven_depmap org.apache.velocity %{name}-generic %{version} JPP %{name}-generic
%add_to_maven_depmap org.apache.velocity %{name}-view %{version} JPP %{name}-view

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%if %with_struts
%{_javadir}/%{name}.jar
%endif
%{_javadir}/%{name}-generic.jar
%{_javadir}/%{name}-view.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc CONTRIBUTORS LICENSE NOTICE README.txt STATUS WHY_THREE_JARS.txt

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Mon Nov 28 2011 gil <gil> 2.0-3.mga2
+ Revision: 173263
- enable struts 1.3.10 support

* Sat Oct 29 2011 dmorgan <dmorgan> 2.0-2.mga2
+ Revision: 159353
- Build w/o struts support for now

  + gil <gil>
    - added struts support
    - added m2 pom
    - imported package velocity-tools

